Index: /trunk/src/VBox/Additions/common/VBoxGuest/Makefile.kmk
===================================================================
--- /trunk/src/VBox/Additions/common/VBoxGuest/Makefile.kmk	(revision 70349)
+++ /trunk/src/VBox/Additions/common/VBoxGuest/Makefile.kmk	(revision 70350)
@@ -50,5 +50,5 @@
  VBoxGuest_DEFS.solaris  = VBOX_SVN_REV=$(VBOX_SVN_REV)
  VBoxGuest_DEFS.win      = VBOX_GUESTDRV_WITH_RELEASE_LOGGER
- VBoxGuest_DEFS.win.x86  = TARGET_NT4
+ VBoxGuest_DEFS.win.x86  = TARGET_NT4 TARGET_NT3 RT_WITHOUT_NOCRT_WRAPPERS
  VBoxGuest_DEFS.darwin   = VBOX_GUESTDRV_WITH_RELEASE_LOGGER
  ifeq ($(KBUILD_TYPE),release)
@@ -85,5 +85,8 @@
     VBoxGuest_SDKS       = ReorderCompilerIncs $(VBOX_WINDDK_GST_NT4)
     VBoxGuest_LIBS       = \
+    	$(VBOX_LIB_VBGL_R0BASE) \
+    	$(VBOX_LIB_IPRT_GUEST_R0) \
     	$(PATH_SDK_$(VBOX_WINDDK_GST_NT4)_LIB)/exsup.lib \
+    	$(PATH_SDK_$(VBOX_WINDDK_GST_NT4)_LIB)/int64.lib \
     	$(PATH_SDK_$(VBOX_WINDDK_GST_NT4)_LIB)/ntoskrnl.lib \
     	$(PATH_SDK_$(VBOX_WINDDK_GST_NT4)_LIB)/hal.lib
@@ -94,5 +97,5 @@
    endif
    VBoxGuest_USES.win += vboximportchecker
-   VBoxGuest_VBOX_IMPORT_CHECKER.win.x86 = nt4/r0
+   VBoxGuest_VBOX_IMPORT_CHECKER.win.x86 = nt31/r0
    VBoxGuest_VBOX_IMPORT_CHECKER.win.amd64 = xp64/r0
   endif # win
@@ -108,8 +111,11 @@
   VBoxGuest_SOURCES     += \
   	VBoxGuest.cpp
-  ifeq ($(KBUILD_TARGET), win)
-   VBoxGuest_SOURCES += \
+  VBoxGuest_SOURCES.win += \
   	win/VBoxGuest.rc
-  endif
+  VBoxGuest_SOURCES.win.x86 += \
+       ../../../Runtime/common/string/strcmp.asm \
+       ../../../Runtime/common/string/strchr.asm \
+       ../../../Runtime/r0drv/nt/nt3fakes-r0drv-nt.cpp \
+       ../../../Runtime/r0drv/nt/nt3fakesA-r0drv-nt.asm
   VBoxGuest_LIBS        += \
   	$(VBOX_LIB_VBGL_R0BASE) \
@@ -159,31 +165,4 @@
 
  VBoxGuest.cpp_DEFS     = VBOX_SVN_REV=$(VBOX_SVN_REV)
-
- if "$(KBUILD_TARGET)" == "win" && defined(VBOX_WITH_NT3_ADDITIONS)
-  #
-  # Windows NT 3.x driver.
-  #
-  SYSMODS.x86 += VBoxGuestNT3
-  VBoxGuestNT3_EXTENDS = VBoxGuest
-  VBoxGuestNT3_INSTTYPE.win = both
-  VBoxGuestNT3_SDKS    = ReorderCompilerIncs $(VBOX_WINDDK_GST_NT4)
-  VBoxGuestNT3_DEFS    = $(VBoxGuest_DEFS) TARGET_NT4 TARGET_NT3 RT_WITHOUT_NOCRT_WRAPPERS
-  VBoxGuestNT3_SOURCES = \
-  	VBoxGuest.cpp \
-  	VBoxGuest-$(KBUILD_TARGET).cpp \
-       ../../../Runtime/common/string/strcmp.asm \
-       ../../../Runtime/common/string/strchr.asm \
-       ../../../Runtime/r0drv/nt/nt3fakes-r0drv-nt.cpp \
-       ../../../Runtime/r0drv/nt/nt3fakesA-r0drv-nt.asm \
-  	win/VBoxGuest.rc
-  VBoxGuestNT3_LIBS    = \
-  	$(VBOX_LIB_IPRT_GUEST_R0_NT4) \
-  	$(PATH_SDK_$(VBOX_WINDDK_GST_NT4)_LIB)/exsup.lib \
-  	$(PATH_SDK_$(VBOX_WINDDK_GST_NT4)_LIB)/int64.lib \
-  	$(PATH_SDK_$(VBOX_WINDDK_GST_NT4)_LIB)/ntoskrnl.lib \
-  	$(PATH_SDK_$(VBOX_WINDDK_GST_NT4)_LIB)/hal.lib \
-  	$(VBOX_LIB_VBGL_R0BASE)
-  VBoxGuestNT3_VBOX_IMPORT_CHECKER.win.x86 = nt31/r0
- endif # win
 endif # enabled
 
Index: /trunk/src/VBox/Additions/common/VBoxGuest/win/VBoxGuestInst.cpp
===================================================================
--- /trunk/src/VBox/Additions/common/VBoxGuest/win/VBoxGuestInst.cpp	(revision 70349)
+++ /trunk/src/VBox/Additions/common/VBoxGuest/win/VBoxGuestInst.cpp	(revision 70350)
@@ -54,6 +54,5 @@
     }
 
-    uint32_t const uMajorNtVer  = GetVersion() & 0xff;
-    const char    *pszSlashName = uMajorNtVer < 4 ? "\\VBoxGuestNT3.sys" : "\\VBoxGuest.sys";
+    const char    *pszSlashName = "\\VBoxGuest.sys";
     char szDriver[MAX_PATH * 2];
     GetCurrentDirectory(MAX_PATH, szDriver);
@@ -63,19 +62,4 @@
         GetSystemDirectory(szDriver, sizeof(szDriver));
         strcat(strcat(szDriver, "\\drivers"), pszSlashName);
-
-        /* Try FAT name abbreviation. */
-        if (   GetFileAttributesA(szDriver) == INVALID_FILE_ATTRIBUTES
-            && uMajorNtVer < 4)
-        {
-            pszSlashName = "\\VBoxGst3.sys";
-            GetCurrentDirectory(MAX_PATH, szDriver);
-            strcat(szDriver, pszSlashName);
-            if (GetFileAttributesA(szDriver) == INVALID_FILE_ATTRIBUTES)
-            {
-                GetSystemDirectory(szDriver, sizeof(szDriver));
-                strcat(strcat(szDriver, "\\drivers"), pszSlashName);
-
-            }
-        }
     }
 